Index: branches/src/ProcessManagement/ProcessManagement/Forms/Master/BudgetItem/FrmBudgetItemAux.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/Master/BudgetItem/FrmBudgetItemAux.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/Master/BudgetItem/FrmBudgetItemAux.cs	(revision 352)
@@ -0,0 +1,941 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Text;
+using System.Windows.Forms;
+using System.Collections;
+using System.Linq;
+
+using log4net;
+using log4net.Appender;
+using log4net.Repository.Hierarchy;
+
+using ProcessManagement.Common;
+using ProcessManagement.DB.IOAccess;
+using ProcessManagement.DataModel;
+using ProcessManagement.DB.Core;
+using ProcessManagement.Forms.SubForms;
+using ProcessManagement.Forms.CustomControls;
+using ProcessManagement.Forms.ControlsAction;
+
+namespace ProcessManagement.Forms.Master
+{
+    public partial class FrmBudgetItem
+    {
+
+        #region 画面ロック
+        /// <summary>
+        /// 画面ロック
+        /// </summary>
+        private void ControlLock(bool bctrl = true)
+        {
+            try
+            {
+                cmbSelectData.Enabled = bctrl;
+                btnAdd.Enabled = bctrl;
+                btnDel.Enabled = bctrl;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 画面クリア
+        /// <summary>
+        /// 画面クリア
+        /// </summary>
+        private void ClearDispEditArea()
+        {
+            try
+            {
+                LblTitle.Text = string.Empty;
+                LblTitle.BackColor = DataBackColors[(int)DataTypeDef.Empty];
+                dgvEdit.Rows.Clear();
+                cmbSelectData.DataSource = null;
+                cmbSelectData.Items.Clear();
+                cmbSelectData.Text = "";
+
+                // フィールドロック
+                ControlLock(false);
+
+                m_bChengeAns = false;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 取得データ並び
+        /// <summary>
+        /// 取得データ並び
+        /// </summary>
+        private enum GetData
+        {
+            BlockCode = 0,
+            GroupCode,
+            ComponentCode,
+            ItemCode,
+            ElementsName,
+        }
+        #endregion
+
+        #region データ取得SQL作成
+        /// <summary>
+        /// データ取得SQL作成
+        /// </summary>
+        private void CreateGetDataSQL(ref StringBuilder strSQL)
+        {
+            try
+            {
+                // 予算書集計コードマスタ取得SQL作成
+                strSQL.Append("Select");
+                strSQL.Append(" A.BlockCode");
+                strSQL.Append(", A.GroupCode");
+                strSQL.Append(", A.ComponentCode");
+                strSQL.Append(", A.ItemCode");
+                strSQL.Append(", A.ElementsName");
+                strSQL.Append(" From");
+                strSQL.Append(" budgetsumcode As A");
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 初期時データ取得
+        /// <summary>
+        /// 初期時データ取得
+        /// </summary>
+        private bool DispGridData()
+        {
+            IOMBudgetSumCode ebcDB = new IOMBudgetSumCode();
+            try
+            {
+                // 予算書集計コードマスタ取得
+                StringBuilder strSQL = new StringBuilder();
+                // データ取得SQL作成
+                CreateGetDataSQL(ref strSQL);
+                strSQL.Append(" Order by A.BlockCode Asc, A.GroupCode Asc");
+
+                ArrayList bscList = new ArrayList();
+                if (!ebcDB.ExecuteReader(strSQL.ToString(), ref bscList)) return false;
+
+                DataGridView dgv = dgvList;
+                dgv.Rows.Clear();
+
+                // 公共工事
+                SetBlkTitleRow((int)BlockNo.PublicWorks);
+                // 公共工事
+                ExistsDataDisp(bscList, (int)BlockNo.PublicWorks, (int)GroupNo.Empty);
+
+                // 工事費
+                SetBlkTitleRow((int)BlockNo.TotalCosts);
+                // 処分費等
+                ExistsDataDisp(bscList, (int)BlockNo.TotalCosts, (int)GroupNo.Dispose);
+
+                // 工事価格
+                SetBlkTitleRow((int)BlockNo.ConstructionPrice);
+                // 一般管理費
+                ExistsDataDisp(bscList, (int)BlockNo.ConstructionPrice, (int)GroupNo.UsualManage);
+
+                // 工事原価
+                SetBlkTitleRow((int)BlockNo.ConstructionCosts);
+                // 現場管理費
+                ExistsDataDisp(bscList, (int)BlockNo.ConstructionCosts, (int)GroupNo.FieldManage);
+
+                // 純工事費
+                SetBlkTitleRow((int)BlockNo.NetConstruction);
+                // 共通仮設費
+                ExistsDataDisp(bscList, (int)BlockNo.NetConstruction, (int)GroupNo.CommonTemp);
+
+                // 直接工事費
+                SetBlkTitleRow((int)BlockNo.DirectConstruction);
+                // 解体工事費
+                ExistsDataDisp(bscList, (int)BlockNo.DirectConstruction, (int)GroupNo.DemolitionWork);
+                // 建築工事費
+                ExistsDataDisp(bscList, (int)BlockNo.DirectConstruction, (int)GroupNo.ConstrWork);
+                // 電気設備工事費
+                ExistsDataDisp(bscList, (int)BlockNo.DirectConstruction, (int)GroupNo.ElectricalWork);
+                // 機械設備工事費
+                ExistsDataDisp(bscList, (int)BlockNo.DirectConstruction, (int)GroupNo.MachineryWork);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                ebcDB.close(); ebcDB = null;
+            }
+        }
+        #endregion
+
+        #region ブロックタイトル行セット
+        /// <summary>
+        /// ブロックタイトル行セット
+        /// </summary>
+        private void SetBlkTitleRow(int nBlkCode)
+        {
+                DataGridView dgv = dgvList;
+            try
+            {
+                // 行追加
+                int RowCnt = dgv.Rows.Add(1);
+
+                // ナンバー取得
+                DataGridViewRow[] TargetRow = dgv.Rows.Cast<DataGridViewRow>()
+                                                        .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.DataType].Value) == (int)DataTypeDef.BlockTitle)
+                                                        .ToArray();
+                int nNo = 1;
+                if (TargetRow.Length > 0) nNo = TargetRow.Length + 1;
+
+                // タイトルセット
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.DispOrder].Value = string.Format("{0}", nNo);
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.NameString].Value = BlockTitle[nBlkCode];
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.DataType].Value = (int)DataTypeDef.BlockTitle;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.BlockCode].Value = nBlkCode;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.GroupCode].Value = 0;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.ComponentCode].Value = 0;
+
+                // 行色変更
+                dgv.Rows[RowCnt].DefaultCellStyle.BackColor = DataBackColors[(int)DataTypeDef.BlockTitle];
+                dgv.Rows[RowCnt].DefaultCellStyle.ForeColor = DataForekColors[(int)DataExistsDef.OnExists];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region グループタイトル行セット
+        /// <summary>
+        /// グループタイトル行セット
+        /// </summary>
+        private void SetGrpTitleRow(int nBlkCode, int nGrpCode)
+        {
+            try
+            {
+                DataGridView dgv = dgvList;
+                // 行追加
+                int RowCnt = dgv.Rows.Add(1);
+
+                // ナンバー取得
+                DataGridViewRow[] BlkRow = dgv.Rows.Cast<DataGridViewRow>()
+                                                        .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.BlockCode].Value) == nBlkCode
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispListCol.DataType].Value) == (int)DataTypeDef.BlockTitle)
+                                                        .ToArray();
+
+                DataGridViewRow[] GrpRow = dgv.Rows.Cast<DataGridViewRow>()
+                                                        .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.BlockCode].Value) == nBlkCode
+                                                        && CommonMotions.cnvInt(x.Cells[(int)DispListCol.DataType].Value) == (int)DataTypeDef.GroupTitle)
+                                                        .ToArray();
+                int nBLkNo = CommonMotions.cnvInt(BlkRow[0].Cells[(int)DispListCol.DispOrder].Value);
+                int nNo = 1;
+                if (GrpRow.Length > 0) nNo = GrpRow.Length + 1;
+
+                // タイトルセット
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.DispOrder].Value = string.Format("{0}-{1}", nBLkNo, nNo);
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.NameString].Value = GroupTitle[nGrpCode];
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.DataType].Value = (int)DataTypeDef.GroupTitle;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.BlockCode].Value = nBlkCode;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.GroupCode].Value = nGrpCode;
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.ComponentCode].Value = 0;
+
+                // 行色変更
+                dgv.Rows[RowCnt].DefaultCellStyle.BackColor = DataBackColors[(int)DataTypeDef.GroupTitle];
+                dgv.Rows[RowCnt].DefaultCellStyle.ForeColor = DataForekColors[(int)DataExistsDef.OnExists];
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 対象工事表示処理
+        /// <summary>
+        /// 対象工事表示処理
+        /// </summary>
+        private void ExistsDataDisp(ArrayList bscList, int nBlockCode, int nGroupCode)
+        {
+            DataGridView dgv = dgvList;
+            try
+            {
+                // タイトルセット
+                if (nGroupCode > (int)GroupNo.Empty) SetGrpTitleRow(nBlockCode, nGroupCode);
+
+                // グループ№取得
+                int nGrpCnt = 1;
+                DataGridViewRow[] GrpRow = dgv.Rows.Cast<DataGridViewRow>()
+                                        .Where(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.BlockCode].Value) == nBlockCode
+                                        && CommonMotions.cnvInt(x.Cells[(int)DispListCol.DataType].Value) == (int)DataTypeDef.GroupTitle)
+                                        .ToArray();
+                if (GrpRow.Length > 0) nGrpCnt = GrpRow.Length;
+
+                int nCompNo = 1;
+                int nItemNo = 1;
+                int nBlkCode = 0;
+                int nGrpCode = 0;
+                int nCompCode = 0;
+                int nItemCode = 0;
+                foreach (object[] CurRec in bscList)
+                {
+                    nBlkCode = CommonMotions.cnvInt(CurRec[(int)GetData.BlockCode]);
+                    nGrpCode = CommonMotions.cnvInt(CurRec[(int)GetData.GroupCode]);
+                    nCompCode = CommonMotions.cnvInt(CurRec[(int)GetData.ComponentCode]);
+                    nItemCode = CommonMotions.cnvInt(CurRec[(int)GetData.ItemCode]);
+
+                    // 対象行以外は処理しない
+                    if (nBlkCode == nBlockCode && nGrpCode == nGroupCode) { }
+                    else { continue; }
+
+                    // 行追加
+                    int RowCnt = dgv.Rows.Add(1);
+                    int PrevRow = 0;
+                    if (RowCnt > 0) PrevRow= RowCnt - 1;
+
+                    // データセット
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.DataType].Value = (int)DataTypeDef.DataRow1;
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.BlockCode].Value = nBlockCode;
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.GroupCode].Value = nGroupCode;
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.ComponentCode].Value = nCompCode;
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.ItemCode].Value = nItemCode;
+
+                    string strConstrName = CommonMotions.cnvString(CurRec[(int)GetData.ElementsName]);
+
+                    if (nGrpCode < 1)
+                    {
+                        int wrk1 = CommonMotions.cnvInt(dgv.Rows[PrevRow].Cells[(int)DispListCol.ComponentCode].Value);
+                        if (wrk1 > 0 && wrk1 != nCompCode) nCompNo++;
+
+                        dgv.Rows[RowCnt].Cells[(int)DispListCol.DispOrder].Value = string.Format("{0}-{1}", nBlkCode, nCompNo);
+                        // 行色変更
+                        dgv.Rows[RowCnt].DefaultCellStyle.BackColor = DataBackColors[(int)DataTypeDef.DataRow1];
+                    }
+                    else if (nItemCode < 1)
+                    {
+                        int wrk1 = CommonMotions.cnvInt(dgv.Rows[PrevRow].Cells[(int)DispListCol.ComponentCode].Value);
+                        if (wrk1 > 0 && wrk1 != nCompCode) nCompNo++;
+
+                        dgv.Rows[RowCnt].Cells[(int)DispListCol.DispOrder].Value = string.Format("{0}-{1}-{2}", nBlkCode, nGrpCnt, nCompNo);
+                        // 行色変更
+                        dgv.Rows[RowCnt].DefaultCellStyle.BackColor = DataBackColors[(int)DataTypeDef.DataRow1];
+                    }
+                    else
+                    {
+                        int wrk1 = CommonMotions.cnvInt(dgv.Rows[PrevRow].Cells[(int)DispListCol.ItemCode].Value);
+                        if (wrk1 > 0 && wrk1 != nItemCode) nCompNo++;
+
+                        dgv.Rows[RowCnt].Cells[(int)DispListCol.DispOrder].Value = string.Format("{0}-{1}-{2}-{3}", nBlkCode, nGrpCnt, nCompNo, nItemNo);
+                        // 行色変更
+                        dgv.Rows[RowCnt].DefaultCellStyle.BackColor = DataBackColors[(int)DataTypeDef.DataRow2];
+                        nItemNo++;
+                    }
+                    dgv.Rows[RowCnt].Cells[(int)DispListCol.NameString].Value = strConstrName;
+
+                    // 表示文字色セット
+                    dgv.Rows[RowCnt].DefaultCellStyle.ForeColor = DataForekColors[(int)DataExistsDef.OnExists];
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                // 行追加
+                int RowCnt = dgv.Rows.Add(1);
+                dgv.Rows[RowCnt].Cells[(int)DispListCol.DataType].Value = (int)DataTypeDef.Empty;
+            }
+        }
+        #endregion
+
+        #region 画面項目のチェック
+        /// <summary>
+        /// 画面項目のチェック
+        /// </summary>
+        /// <returns></returns>
+        private bool DispFeildCheck()
+        {
+            try
+            {
+                DataGridView dgv = dgvEdit;
+
+                if (LblTitle.Text.Length < 1) return false;
+
+                if (dgv.RowCount < 1)
+                {
+                    MessageBox.Show("データが選択されていません。"
+                                        , "登録エラー"
+                                        , MessageBoxButtons.OK
+                                        , MessageBoxIcon.Error);
+                    return false;
+                }
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 予算書集計コードマスタ登録
+        /// <summary>
+        /// 予算書集計コードマスタ登録
+        /// </summary>
+        private bool DataEntry()
+        {
+            IOMBudgetSumCode bscDB = new IOMBudgetSumCode();
+            try
+            {
+                if (MessageBox.Show("予算書集計コードマスタを更新します、よろしいですか？"
+                                    , "登録確認"
+                                    , MessageBoxButtons.YesNo
+                                    , MessageBoxIcon.Question) != DialogResult.Yes) return false;
+
+                DataGridView dgv = dgvEdit;
+
+                int nBlkNo = 0;
+                int nGrpNo = 0;
+                int nCompNo = 0;
+                List<BudgetSumCode> bscList = new List<BudgetSumCode>();
+                foreach (DataGridViewRow CurRow in dgv.Rows)
+                {
+                    BudgetSumCode wrkRec = new BudgetSumCode();
+
+                    wrkRec.BlockCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.BlockCode].Value);            // ブロック番号
+                    wrkRec.GroupCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.GroupCode].Value);            // グループ番号
+                    wrkRec.ComponentCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.ComponentCode].Value);    // 構成キー
+                    wrkRec.ItemCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.ItemCode].Value);              // 工種キー
+                    wrkRec.ElementsName = CommonMotions.cnvString(CurRow.Cells[(int)DispEditCol.NameString].Value);     // 構成名称
+
+                    nBlkNo = wrkRec.BlockCode;
+                    nGrpNo = wrkRec.GroupCode;
+                    nCompNo = wrkRec.ComponentCode;
+                    bscList.Add(wrkRec);
+                }
+                if (bscList.Count < 1) return true;
+
+                // Transaction
+                bscDB.connect(); bscDB.beginTran();
+
+                StringBuilder strSQL = new StringBuilder();
+
+                // グループ・構成の登録によってセットするコードが違う
+                if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.GroupTitle])
+                {   // グループ単位でデータ削除
+                    strSQL.Append(bscDB.CreatePrimarykeyString(nBlkNo, nGrpNo));
+                    strSQL.Append(" And ItemCode = 0");
+                }
+                else if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.DataRow1])
+                {   // 構成単位でデータ削除
+                    strSQL.Append(bscDB.CreatePrimarykeyString(nBlkNo, nGrpNo, nCompNo));
+                    strSQL.Append(" And ItemCode > 0");
+                }
+                // データ削除
+                bscDB.DeleteAction(strSQL.ToString(), false);
+
+                // 一括登録
+                if (!bscDB.InsertAction(bscList, false))
+                {
+                    bscDB.rollback();
+                    MessageBox.Show("予算書集計コードマスタ登録エラーです。", "登録エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return false;
+                }
+
+                bscDB.commit();
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+            finally
+            {
+                bscDB.close(); bscDB = null;
+            }
+        }
+        #endregion
+
+        #region 編集データ表示処理
+        /// <summary>
+        /// 編集データ表示処理
+        /// </summary>
+        private void DispEditData()
+        {
+            try
+            {
+                // 画面クリア
+                ClearDispEditArea();
+
+                DataGridView dgvL = dgvList;
+                // カレント行取得
+                DataGridViewRow CurRow = dgvL.CurrentRow;
+
+                // ブロック・グループ・構成コードを取得する
+                int nBlkCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispListCol.BlockCode].Value);
+                if (nBlkCode < 1) return;
+
+                int nGrpCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispListCol.GroupCode].Value);
+                if (nGrpCode < 1 && nBlkCode != (int)BlockNo.PublicWorks) return;
+
+                int nCompCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispListCol.ComponentCode].Value);
+                if (nCompCode > 0)
+                {
+                    // 工種編集
+                    EditItem(nBlkCode, nGrpCode, nCompCode);
+                    return;
+                }
+                // アイテムの編集ではない場合は構成を編集する
+                EditComponent(nBlkCode, nGrpCode);
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 構成編集
+        /// <summary>
+        /// 構成編集
+        /// </summary>
+        /// <returns></returns>
+        private void EditComponent(int nBlkCode, int nGrpCode)
+        {
+            IOMBudgetSumCode bscDB = new IOMBudgetSumCode();
+            try
+            {
+                DataGridView dgvL = dgvList;
+
+                StringBuilder strSQL = new StringBuilder();
+                // データ取得SQL作成
+                CreateGetDataSQL(ref strSQL);
+                strSQL.Append(bscDB.CreatePrimarykeyString(nBlkCode, nGrpCode));
+                strSQL.Append(" And A.ItemCode = 0");
+                strSQL.Append(" Order by A.BlockCode Asc, A.GroupCode Asc");
+
+                ArrayList bscList = new ArrayList();
+                if (!bscDB.ExecuteReader(strSQL.ToString(), ref bscList)) return;
+
+                // 処理タイトル取得
+                DataGridViewRow TitleRow = dgvL.Rows.Cast<DataGridViewRow>().First(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.GroupCode].Value) == nGrpCode);
+                LblTitle.BackColor = DataBackColors[(int)DataTypeDef.GroupTitle];
+                if (TitleRow != null)
+                    LblTitle.Text = CommonMotions.cnvString(TitleRow.Cells[(int)DispListCol.NameString].Value);
+
+                DataGridView dgvE = dgvEdit;
+
+                int nNo = 0;
+                foreach (object[] CurRec in bscList)
+                {
+                    // 行追加
+                    int RowCnt = dgvE.Rows.Add(1);
+
+                    int nCompCode = CommonMotions.cnvInt(CurRec[(int)GetData.ComponentCode]);
+                    // データセット
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.BlockCode].Value = nBlkCode;
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.GroupCode].Value = nGrpCode;
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.ComponentCode].Value = nCompCode;
+
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.DispOrder].Value = ++nNo;
+
+                    string strConstrName = CommonMotions.cnvString(CurRec[(int)GetData.ElementsName]);
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.NameString].Value = strConstrName;
+                }
+
+                // 構成項目コンボボックスセット
+                SetcmbSelectDataCompo();
+
+                //// データが登録されていれば入力させない
+                //if (dgvE.RowCount < 1)
+                //{
+                // フィールドロック解除
+                ControlLock(true);
+                //}
+                //else
+                //{
+                //    // フィールドロック
+                //ControlLock(false);
+                //btnDel.Enabled = true;
+                //}
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                bscDB.close(); bscDB = null;
+            }
+        }
+        #endregion
+
+        #region 工種編集
+        /// <summary>
+        /// 工種編集
+        /// </summary>
+        private void EditItem(int nBlkCode, int nGrpCode, int nCompCode)
+        {
+            IOMBudgetSumCode bscDB = new IOMBudgetSumCode();
+            try
+            {
+                DataGridView dgvL = dgvList;
+
+                // 共通仮設以外は対象外
+                if (nGrpCode != (int)GroupNo.CommonTemp)
+                {
+                    string strMsg = string.Format("{0}以外は中項目を入力できません。", GroupTitle[(int)GroupNo.CommonTemp].Replace(" ", "").Replace("　", ""));
+                    MessageBox.Show(strMsg
+                                        , "選択エラー"
+                                        , MessageBoxButtons.OK
+                                        , MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 工種行は対象外
+                if (dgvL.CurrentRow.DefaultCellStyle.BackColor == DataBackColors[(int)DataTypeDef.DataRow2])
+                {
+                    MessageBox.Show("中項目より下位の項目は入力できません。"
+                                        , "選択エラー"
+                                        , MessageBoxButtons.OK
+                                        , MessageBoxIcon.Error);
+                    return;
+                }
+
+                StringBuilder strSQL = new StringBuilder();
+                // データ取得SQL作成
+                CreateGetDataSQL(ref strSQL);
+                strSQL.Append(bscDB.CreatePrimarykeyString(nBlkCode, nGrpCode, nCompCode));
+                strSQL.Append(" And A.ItemCode > 0");
+                strSQL.Append(" Order by A.BlockCode Asc, A.GroupCode Asc");
+
+                ArrayList bscList = new ArrayList();
+                if (!bscDB.ExecuteReader(strSQL.ToString(), ref bscList)) return;
+
+                // 処理タイトル取得
+                DataGridViewRow TitleRow = dgvL.Rows.Cast<DataGridViewRow>().First(x => CommonMotions.cnvInt(x.Cells[(int)DispListCol.GroupCode].Value) == nGrpCode
+                                                                                    && CommonMotions.cnvInt(x.Cells[(int)DispListCol.ComponentCode].Value) == nCompCode);
+                LblTitle.BackColor = DataBackColors[(int)DataTypeDef.DataRow1];
+                if (TitleRow != null)
+                    LblTitle.Text = CommonMotions.cnvString(TitleRow.Cells[(int)DispListCol.NameString].Value);
+
+                DataGridView dgvE = dgvEdit;
+
+                int nNo = 0;
+                foreach (object[] CurRec in bscList)
+                {
+                    // 行追加
+                    int RowCnt = dgvE.Rows.Add(1);
+
+                    int nItemCode = CommonMotions.cnvInt(CurRec[(int)GetData.ItemCode]);
+                    // データセット
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.BlockCode].Value = nBlkCode;
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.GroupCode].Value = nGrpCode;
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.ComponentCode].Value = nCompCode;
+
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.ItemCode].Value = nItemCode;
+
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.DispOrder].Value = ++nNo;
+
+                    string strConstrName = CommonMotions.cnvString(CurRec[(int)GetData.ElementsName]);
+                    dgvE.Rows[RowCnt].Cells[(int)DispEditCol.NameString].Value = strConstrName;
+                }
+
+                // 工種コンボボックスセット
+                SetcmbSelectDataItem();
+
+                //// データが登録されていれば入力させない
+                //if (dgvE.RowCount < 1)
+                //{
+                // フィールドロック解除
+                ControlLock(true);
+                //}
+                //else
+                //{
+                //// フィールドロック
+                //ControlLock(false);
+                //btnDel.Enabled = true;
+                //}
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                bscDB.close(); bscDB = null;
+            }
+        }
+        #endregion
+
+        #region 構成項目コンボボックスセット
+        /// <summary>
+        /// 構成項目コンボボックスセット
+        /// </summary>
+        private void SetcmbSelectDataCompo()
+        {
+            IOMComponent compDB = new IOMComponent();
+            try
+            {
+                // 構成項目マスタを検索する
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.AppendFormat(" Where DeleteFlg = {0}", (int)CommonDefine.DataRowDeleteDef.Exists);
+                strSQL.Append(" Order By DisplayOrder Asc, ComponentCode Asc");
+
+                // 構成項目マスタ読込
+                List<ComponentMaster> arList = new List<ComponentMaster>();
+                if (!compDB.SelectAction(strSQL.ToString(), ref arList)) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                DataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (ComponentMaster work in arList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(work.ComponentCode, work.ComponentName);
+                    DataList.Add(keyval);
+                }
+
+                cmbSelectData.DataSource = null;
+                cmbSelectData.Items.Clear();
+                cmbSelectData.Text = "";
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbSelectData, DataList);
+
+                cmbSelectData.SelectedValue = 0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                compDB.close(); compDB = null;
+            }
+        }
+        #endregion
+
+        #region 工種コンボボックスセット
+        /// <summary>
+        /// 工種コンボボックスセット
+        /// </summary>
+        private void SetcmbSelectDataItem()
+        {
+            IOMConstructionItem ItemDB = new IOMConstructionItem();
+            try
+            {
+                DataGridView dgvL = dgvList;
+                // カレント行取得
+                DataGridViewRow CurRow = dgvL.CurrentRow;
+                int nCompCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispListCol.ComponentCode].Value);
+
+                // 工種マスタを検索する
+                StringBuilder strSQL = new StringBuilder();
+                strSQL.Append("Select");
+                strSQL.Append(" B.ItemCode");
+                strSQL.Append(", B.ItemName");
+                strSQL.Append(" From");
+                strSQL.Append(" Componentlinkmaster As A");
+                strSQL.Append(" Left Join constructionitemmaster As B");
+                strSQL.Append(" On B.ItemCode = A.ItemCode");
+                strSQL.Append(" Where");
+                strSQL.AppendFormat(" A.ComponentCode = {0}", nCompCode);
+                strSQL.AppendFormat(" And B.DeleteFlg = {0}", (int)CommonDefine.DataRowDeleteDef.Exists);
+                strSQL.Append(" Order By B.DisplayOrder");
+
+                // 工種マスタ読込
+                ArrayList arList = new ArrayList();
+                if (!ItemDB.ExecuteReader(strSQL.ToString(), ref arList)) return;
+
+                List<KeyValuePair<int, string>> DataList = new List<KeyValuePair<int, string>>();
+                DataList.Add(new KeyValuePair<int, string>(0, ""));
+
+                foreach (object[] work in arList)
+                {
+                    KeyValuePair<int, string> keyval = new KeyValuePair<int, string>(CommonMotions.cnvInt(work[0])
+                                                                                        , CommonMotions.cnvString(work[1]));
+                    DataList.Add(keyval);
+                }
+
+                cmbSelectData.DataSource = null;
+                cmbSelectData.Items.Clear();
+                cmbSelectData.Text = "";
+
+                // コンボボックス初期表示
+                ComboBoxAction.InitDataSetCombBox(cmbSelectData, DataList);
+
+                cmbSelectData.SelectedValue = 0;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                ItemDB.close(); ItemDB = null;
+            }
+        }
+        #endregion
+
+        #region 行データの追加
+        /// <summary>
+        /// 行データの追加
+        /// </summary>
+        private void AddRowData()
+        {
+            try
+            {
+                DataGridView dgv = dgvEdit;
+
+                //// 2行以上は選択させない
+                //if (dgvEdit.RowCount > 0)
+                //{
+                //    MessageBox.Show("２行以上は選択できません。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                //    return;
+                //}
+
+                // 選択エラー
+                int CurrentCode = CommonMotions.cnvInt(cmbSelectData.SelectedValue);
+                if (CurrentCode < 1)
+                {
+                    MessageBox.Show("データが選択されていません。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 存在確認
+                DataGridViewRow[] FindRow = dgv.Rows.Cast<DataGridViewRow>().Where(x => CommonMotions.cnvInt(x.Cells[(int)DispEditCol.ComponentCode].Value) == CurrentCode).ToArray();
+                if (FindRow.Count() > 0)
+                {
+                    MessageBox.Show("既に選択されています。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 選択データグループ取得
+                DataGridView dgvL = dgvList;
+                int nBlkCode = CommonMotions.cnvInt(dgvL.CurrentRow.Cells[(int)DispListCol.BlockCode].Value);
+                int nGrpCode = CommonMotions.cnvInt(dgvL.CurrentRow.Cells[(int)DispListCol.GroupCode].Value);
+                int nCompCode = CommonMotions.cnvInt(dgvL.CurrentRow.Cells[(int)DispListCol.ComponentCode].Value);
+
+                // 行追加
+                int RowCnt = dgv.Rows.Add(1);
+                int nNo = dgv.RowCount;
+
+                dgv.Rows[RowCnt].Cells[(int)DispEditCol.BlockCode].Value = nBlkCode;
+                dgv.Rows[RowCnt].Cells[(int)DispEditCol.GroupCode].Value = nGrpCode;
+                // グループ・構成の登録によってセットするコードが違う
+                if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.GroupTitle])
+                {
+                    dgv.Rows[RowCnt].Cells[(int)DispEditCol.ComponentCode].Value = CurrentCode;
+                }
+                else if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.DataRow1])
+                {
+                    dgv.Rows[RowCnt].Cells[(int)DispEditCol.ComponentCode].Value = nCompCode;
+                    dgv.Rows[RowCnt].Cells[(int)DispEditCol.ItemCode].Value = CurrentCode;
+                }
+                dgv.Rows[RowCnt].Cells[(int)DispEditCol.DispOrder].Value = nNo;
+                dgv.Rows[RowCnt].Cells[(int)DispEditCol.NameString].Value = CommonMotions.cnvString(cmbSelectData.Text);
+
+                m_bChengeAns = true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 行データの削除
+        /// <summary>
+        /// 行データの削除
+        /// </summary>
+        private void DelRowData()
+        {
+            IOMBudgetSumCode bscDB = new IOMBudgetSumCode();
+            try
+            {
+                DataGridView dgv = dgvEdit;
+                DataGridViewRow CurRow = dgv.CurrentRow;
+
+                // 選択エラー
+                int GrpCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.GroupCode].Value);
+                int CompCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.ComponentCode].Value);
+                if (GrpCode < 1 || CompCode < 1)
+                {
+                    MessageBox.Show("データが選択されていません。", "選択エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                    return;
+                }
+
+                // 選択確認
+                if (MessageBox.Show("選択された行を削除します。\r\nよろしいでしょうか？", "削除確認",
+                                    MessageBoxButtons.OKCancel, MessageBoxIcon.Question) == DialogResult.Cancel) return;
+
+                // 行削除
+                int nBlockCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.BlockCode].Value);          // ブロック番号
+                int nGroupCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.GroupCode].Value);          // グループ番号
+                int nComponentCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.ComponentCode].Value);  // 構成キー
+                int nItemCode = CommonMotions.cnvInt(CurRow.Cells[(int)DispEditCol.ItemCode].Value);            // 工種キー
+
+                bscDB.connect(); bscDB.beginTran();
+
+                StringBuilder strSQL = new StringBuilder();
+                // グループ・構成の登録によってセットするコードが違う
+                if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.GroupTitle])
+                {
+                    strSQL.Append(bscDB.CreatePrimarykeyString(nBlockCode, nGroupCode, nComponentCode));
+                }
+                else if (LblTitle.BackColor == DataBackColors[(int)DataTypeDef.DataRow1])
+                {
+                    strSQL.Append(bscDB.CreatePrimarykeyString(nBlockCode, nGroupCode, nComponentCode, nItemCode));
+                }
+                BudgetSumCode bscRec = new BudgetSumCode();
+                // 存在確認
+                if (bscDB.SelectAction(strSQL.ToString(), ref bscRec, false))
+                {
+                    // 削除
+                    if (!bscDB.DeleteAction(strSQL.ToString(), false))
+                    {
+                        bscDB.rollback();
+                        MessageBox.Show("予算書集計コードマスタ\r\nデータ削除に失敗しました。", "削除エラー", MessageBoxButtons.OK, MessageBoxIcon.Error);
+                        return;
+                    }
+                }
+
+                bscDB.commit();
+                // 更新エリアクリア
+                ClearDispEditArea();
+
+                // 初期表示
+                DispGridData();
+
+                m_bChengeAns = false;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+            finally
+            {
+                bscDB.close(); bscDB = null;
+            }
+        }
+        #endregion
+    }
+}
